;~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~
;CURRENT STATUS: DONE * LAST UPDATE: 8/22/99 * CURRENT SIZE: 2460 bytes
;~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~
;==============================;
;*Tic Tac Toe* V.1.2           ;
;by Ricky Cobb                 ;
;email arcadesdude@hotmail.com ;
;ICQ# 41440378                 ;
;==============================;
;~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~
;NEW! in ver 1.2 size reduction of *517* bytes!
;also fixed minor textshadow bug so when you turn calc off with os routine(_off) then
;on again it doesnt show a bunch of funky symbols now. (i cleared textshadow)
;mabey ill add linkplay later...(because it funner against a human player)
;~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~
;Known Bugs:
;I dont know of any...
;~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~~-~-~

#include "ti86asm.inc"
.org _asm_exec_ram  ;the begining of the program


 nop
 jp start   ;go to the start of the program
 .dw 0    ;this stuff is for a shell like Rascall or ASE
 .dw Title

Title:
 .db "*TicTacToe*   V.2.0 by Ricky Cobb",0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Define variables (or varis as i call 'em)
upperleft = _textShadow+1  ;these are the tic tac toe grid Upper Left
uppermid = _textShadow+2  ;Upper Middle and so on
upperright = _textShadow+3  ;    |     |
midleft = _textShadow+4   ;   UL | UM  | UR
midmid = _textShadow+5   ;    ---+-----+---
midright = _textShadow+6  ;   ML | MM  | MR
lowerleft = _textShadow+7  ;  ---+-----+---
lowermid = _textShadow+8  ;   LL | LM  | LR
lowerright = _textShadow+9  ;    |     |
temp1 = _textShadow+10   ;these 3 temp varis are for testing 
temp2 = _textShadow+11   ;( its tictactoe 3 in a row duh!)
temp3 = _textShadow+12
win = _textShadow+13   ;0 = no win 1 = win 
t = _textShadow+14    ;t is turn (1 OR 2)
comppeice = _textShadow+15  ;num 1-9
players = _textShadow+16
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

start:
 res appTextSave,(iy+appflags)  ;tell os to not use textshadow area so
         ;i can store data here
 call _runindicoff  ;i hate this thing (it turns off the line in upperright of screen)
  call _flushallmenus  ;flush the menus down the toliet!
  call _clrLCD   ;clears the screen
 
 ld hl,tttpict
 rst 20h
 rst 10h
 jr c,startwopic
startwpic:
 ex de,hl
 ld a,b
 call $46C3
 inc hl
 inc hl
 ld de,$FC00    ;begining of video mem into de
 call DispRLE   ;the picture compresser
 jr playerput
startwopic:
 call _homeup
 ld hl,menutxt
 call _puts
 call _newline
 call _newline
 ld hl,author
 call _puts
 jr srtwopict2
playerput: 
 set textInverse,(iy+textflags)
 ld hl,$0F49
 ld (_penCol),hl
 ld hl,author
 call _vputs
srtwopict2:
 ld hl,$1D49
 ld (_penCol),hl
 ld hl,push2ndtxt
 call _vputs
 ld hl,$2449
 ld (_penCol),hl
 ld hl,push2ndtxt+9
 call _vputs
 ld hl,$3050
 ld (_penCol),hl
 ld hl,playerstxt2
 call _vputs
 ld hl,$3750
 ld (_penCol),hl
 ld hl,playerstxt3
 call _vputs
 ld hl,$0C06
 ld (_curRow),hl
 ld a,5   ;this is that selector (triangle rotated right)
 call _putc
 ld a,1   ;1 into a
 ld (players),a ;a into players variable
chooseplayers:
 halt
 call _get_key
 cp K_EXIT
 jp z,exit
 cp K_UP
 jr z,togplayer
 cp K_DOWN
 jr z,togplayer
 cp K_ENTER
 jr z,resetvaris
 cp K_SECOND
 jr z,resetvaris
 jr chooseplayers
togplayer:
 ld a,(players)
 xor 3 ;if 1 is now 2 if two is now 1
 ld (players),a
 dec a
 jr nz,curto2
 ld hl,$0C07
 ld (_curRow),hl
 ld a,' '   ;erase the old
 call _putc
 ld hl,$0C06
 ld (_curRow),hl
 ld a,5
 call _putc   ;and put the new
 jr chooseplayers
curto2:
 ld hl,$0C06
 ld (_curRow),hl
 ld a,' '
 call _putc
 ld hl,$0C07
 ld (_curRow),hl
 ld a,5
 call _putc
 jr chooseplayers
resetvaris:     ;reset the varibles
cleargraph: 
 ld hl,_plotSScreen  ;this clears graph vid mem so if you
 ld de,_plotSScreen+1 ;had a graph showing
 ld bc,1023    ;it wont when the board
 ld (hl),0    ;comes up  
 ldir           
 res textInverse,(iy+textflags)
 ld hl,upperleft
 ld b,15     ;15 varis to be set to zero (the first 15 above at define varis)
rset1:
 ld (hl),0    ;0 -> (into) each varible that is the grid for ttt (and others)
 inc hl     ;next varible
 djnz rset1    ;dec b jump to rset1 if not zero
 ld a,1     ;1 -> a
 ld (t),a    ;a into turn
drawscreen:
 call _clrLCD     ;_ILine Routine will save some space
 ld h,1 
 ld bc,$0F32
 ld de,$0F00  ;hex and screen cords are not my thing...
 call _ILine      ;OK it works right but i still dont like hex.
 inc b
 inc d
 call _ILine
 ld b,$27
 ld d,b
 call _ILine
 inc b
 inc d
 call _ILine
 ld bc,$0126
 ld de,$3626
 call _ILine
 dec c
 dec e
 call _ILine
 ld c,15
 ld e,c
 call _ILine
 inc c
 inc e
 call _ILine
 call _homeup
 ld hl,xturn
 call _puts
 ld hl,$085B 
 ld (_penCol),hl
 ld hl,menutxt
 call _vputs
 ld hl,$0F5B
 ld (_penCol),hl
 ld hl,threeinrow
 call _vputs
 ld hl,$1E5B
 ld (_penCol),hl
 ld hl,keystxt
 call _vputs
 ld hl,$255B
 ld (_penCol),hl
 ld hl,keytxt2
 call _vputs
 ld hl,$2C5B
 ld (_penCol),hl
 ld hl,keytxt3
 call _vputs
 ld hl,$335B
 ld (_penCol),hl
 ld hl,keytxt4
 call _vputs
 ld hl,$005B 
 ld (_penCol),hl
 ld a,(players) ;check mode
 dec a
 jr nz,dwsc2
 ld hl,playerstxt2 ;display 1p mode
 call _vputs
 jr dispturn
dwsc2
 ld hl,playerstxt3 ;displat 2p mode
 call _vputs
dispturn:     ;main loop starts here
 call _homeup
 ld a,(t) ;get turn
 dec a  ;test with 1
 jr z,t1  ;if 1 goto ti
 ld hl,o  ;else 2 then 
 call _puts ;show O (in turn spot)
 jr keyget
t1:
 ld hl,x  ;show X (in turn spot)
 call _puts
keyget:
 halt
 call _getkey
 cp k1
 jr z,one
 cp k2
 jr z,two
 cp k3
 jr z,three
 cp k4
 jr z,four
 cp k5
 jp z,five
 cp k6
 jp z,six
 cp k7
 jp z,seven
 cp k8
 jp z,eight
 cp k9
 jp z,nine
 cp kNext  ;this is the More key if pushed it is new game
 jp z,resetvaris
 cp kClear  ;menu if pressed
 jp z,menu
 cp kExit  ;I'm not gonna even say what this does...
 jp z,exit
 jr keyget
one:
 ld hl,$0107   ;set placement of peice
 ld (_curRow),hl  ;set placement of peice
 ld hl,lowerleft  ;let hl point to the current spot on ttt grid
 push hl    ;save the current address of grid
 ld a,(lowerleft) ;get value from grid at current spot  
 or a    ;was it 0?
 jp nz,bzzzzz  ;if not (peice was placed before) and goto bzzzzz
 jp turn    ;otherwise it was zero so a piece can be placed!! yippie!
   
      ;the other number labels are the same except for the placement and
      ;current grid spot
two:
 ld hl,$0407
 ld (_curRow),hl
 ld hl,lowermid
 push hl
 ld a,(lowermid)
 or a
 jp nz,bzzzzz
 jp turn
three:
 ld hl,$0707
 ld (_curRow),hl
 ld hl,lowerright
 push hl
 ld a,(lowerright)
 or a
 jp nz,bzzzzz
 jp turn
four:
 ld hl,$0104
 ld (_curRow),hl
 ld hl,midleft
 push hl
 ld a,(midleft)
 or a 
 jp nz,bzzzzz
 jp turn
five:
 ld hl,$0404
 ld (_curRow),hl
 ld hl,midmid
 push hl
 ld a,(midmid)
 or a
 jr nz,bzzzzz
 jr turn 
six:
 ld hl,$0704
 ld (_curRow),hl
 ld hl,midright
 push hl
 ld a,(midright)
 or a 
 jr nz,bzzzzz
 jr turn
seven:
 ld hl,$0102
 ld (_curRow),hl
 ld hl,upperleft
 push hl
 ld a,(upperleft)
 or a 
 jr nz,bzzzzz
 jr turn
eight:
 ld hl,$0402
 ld (_curRow),hl
 ld hl,uppermid
 push hl
 ld a,(uppermid)
 or a 
 jr nz,bzzzzz
 jr turn
nine:
 ld hl,$0702
 ld (_curRow),hl
 ld hl,upperright
 push hl
 ld a,(upperright)
 or a
 jr nz,bzzzzz
 jr turn
bzzzzz:
 pop hl   ;we must pop it even though we dont want 
     ;it so it doesnt screw up the calc when we exit
 ld hl,$373B
 ld (_penCol),hl
 ld hl,error  ;"nope" peice has been placed here already
 call _vputs
 jp keyget
turn:
 ld hl,$373B
 ld (_penCol),hl
 ld hl,blank
 call _vputs
 ld a,(t) ;turn into a
 pop hl  ;re get the value saved
 ld (hl),a ;put the turn into it
 dec a  ;compare with 1
 jr z,turn1 ;if 1 goto lbl turn1
 ld hl,o  ;otherwise it is 2 so put an o on screen
 call _puts
 jr test  ;test for 3 in row or all filled
turn1:
 ld hl,x
 call _puts
 jr test
test:
;loads varis into here then calls main test repeatedly
 ld a,(upperleft)
 ld (temp1),a
 ld a,(uppermid)
 ld (temp2),a
 ld a,(upperright)
 ld (temp3),a
 call maintest
 ld a,(midleft)
 ld (temp1),a
 ld a,(midmid)
 ld (temp2),a
 ld a,(midright)
 ld (temp3),a
 call maintest
 ld a,(lowerleft)
 ld (temp1),a
 ld a,(lowermid)
 ld (temp2),a
 ld a,(lowerright)
 ld (temp3),a
 call maintest
 ld a,(upperleft)
 ld (temp1),a
 ld a,(midleft)
 ld (temp2),a
 ld a,(lowerleft)
 ld (temp3),a
 call maintest
 ld a,(uppermid)
 ld (temp1),a
 ld a,(midmid)
 ld (temp2),a
 ld a,(lowermid)
 ld (temp3),a
 call maintest
 ld a,(upperright)
 ld (temp1),a
 ld a,(midright)
 ld (temp2),a
 ld a,(lowerright)
 ld (temp3),a
 call maintest
 ld a,(upperleft)
 ld (temp1),a
 ld a,(midmid)
 ld (temp2),a
 ld a,(lowerright)
 ld (temp3),a
 call maintest
 ld a,(upperright)
 ld (temp1),a
 ld a,(midmid)
 ld (temp2),a
 ld a,(lowerleft)
 ld (temp3),a
 call maintest
;once here then it is next turn or all squares fileed up or posible win
wintest:  ;win would have been set to one if win occured in maintest label
 xor a  ;0 into a
 ld hl,win ;win address in hl
 cp (hl)  ;compare a (0) with the value at address hl (win vari either 0 or 1)
 jp nz,someonewan ;if values different (i.e. someone has won goto someonewan)
     ;other wise contine with catgame test
allfilledtest:  ;also called catgame (if noone has won)
 ld b,9
 ld hl,upperleft
 xor a 
allfilledloop:
 cp (hl)
 jr z,togturn  ;if one square min is zero then toggle turn
 inc hl
 djnz allfilledloop ;this loop saves 40 bytes
;if it got here its cat game
 call _homeup ;homeup is the same as ld hl,$0000 then
     ;ld (_curRow),hl but is smaller (byte wise)
 ld hl,cat
 call _puts
 jp menu
togturn:
 ld a,(t)
 dec a
 jr z,to2
 ld a,1  ;1p is always human player   
 ld (t),a
 jp dispturn
to2:
 ld a,2
 ld (t),a
 ld a,(players)
 dec a   ;two player may be human or comp
 jr z,compthink ;if comp goto compthink
 jp dispturn  ;otherwise display turn
;;;;;;;;begin comp section 518 bytes;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
compthink:    ;the ai used is almost the same as the ai i have for my basic 
      ;game of ttt
 call _homeup
 ld hl,o
 call _puts
 ld b,35    ;halt counter for slow down (ASM is too freaking fast!!!)
haltloop:
 halt
 djnz haltloop
;;;;;;true comp begin section;;;;;;;;;;;;;;;;;;;;;;
 ld a,30    ;one in 30 chance of messing up
 call random
 or a    ;if z flag set (a = 0 thats a 1 in 30 chance)
 jp z,rplace   ;goto randomplacement of comp peice
;above for random placement of comps piece , (a 'mistake' that the comp made that we all might
;make, like a human might make if you want a 'smart' comp opponent comment out the 
;section above from true comp begin section to jp z,rplace
;The next section is for the computers intellegence.
thought:
;loads varis then tests each possibility
 xor a
 ld (comppeice),a ;compiece to zero
 ld b,1
 ld a,(upperleft)
 ld (temp1),a
 ld a,(uppermid)
 ld (temp2),a
 ld a,(upperright)
 ld (temp3),a
 call comptest
 inc b
 ld a,(midleft)
 ld (temp1),a
 ld a,(midmid)
 ld (temp2),a
 ld a,(midright)
 ld (temp3),a
 call comptest
 inc b
 ld a,(lowerleft)
 ld (temp1),a
 ld a,(lowermid)
 ld (temp2),a
 ld a,(lowerright)
 ld (temp3),a
 call comptest
 inc b
 ld a,(upperleft)
 ld (temp1),a
 ld a,(midleft)
 ld (temp2),a
 ld a,(lowerleft)
 ld (temp3),a
 call comptest
 inc b
 ld a,(uppermid)
 ld (temp1),a
 ld a,(midmid)
 ld (temp2),a
 ld a,(lowermid)
 ld (temp3),a
 call comptest
 inc b
 ld a,(upperright)
 ld (temp1),a
 ld a,(midright)
 ld (temp2),a
 ld a,(lowerright)
 ld (temp3),a
 call comptest
 inc b
 ld a,(upperleft)
 ld (temp1),a
 ld a,(midmid)
 ld (temp2),a
 ld a,(lowerright)
 ld (temp3),a
 call comptest
 inc b
 ld a,(upperright)
 ld (temp1),a
 ld a,(midmid)
 ld (temp2),a
 ld a,(lowerleft)
 ld (temp3),a
 call comptest
 ld a,(comppeice)
 or a
 jr nz,placecomp ;peice ready to be placed
 ld a,(t)  ;other wise change t and cycle back for blocking 
 dec a
 jr z,rplace
 ld (t),a ;1 into a from dec above into turn
 jp thought
rplace:  ;places a peice randomly on board (comp in 1p mode only)
 ld a,9
 call random
 inc a  ;a is now a  num 1-9 
 ld (comppeice),a
 ld hl,upperleft-1
 ld b,a
rplaceloop:
 inc hl   
 djnz rplaceloop  ;get board value for random
 ld a,(hl)
 or a    ;check with zero
 jr z,placecomp  ;if empty then place
 jr rplace   ;else another random
placecomp:
;if here square is not zero and peice ready to be placed peice is comppeice vari
 ld a,2
 ld (t),a
 ld a,(comppeice)
 dec a
 jp z,seven
 dec a
 jp z,eight
 dec a
 jp z,nine
 dec a
 jp z,four
 dec a
 jp z,five
 dec a
 jp z,six
 dec a
 jp z,one
 dec a
 jp z,two
 jp three
comptest: ;the first one 
;b is counter for tests b=1 is ul um ur b=2 is ml mm mr and so on 8 times
 ld a,(temp1)  ;compares first and 2nd temp varis
 ld hl,t
 cp (hl)
 jr nz,ct2   ;varible must be equal to turn
 ld a,(temp1)
 ld hl,temp2
 cp (hl)    ;if not equal next test
 jr nz,ct2   ;if equal AND They are NOT ZERO AND temp3 is 0 then peice can be placed
 ld a,(temp3)
 or a    ;is peice zero?
 jr nz,ct2   ;if not next test
 ld a,b    ;otherwise get the test counter
 ld hl,comppeice
 dec a    ;and place the peice
 call z,ld3   ;too bad theres no such thing as a conditional ld :(
 dec a 
 call z,ld6   ; A| A|0  the first A is temp1 2nd A temp2 0 is temp3
 dec a        ;--+--+--  Note: these tests check for every occurence
 call z,ld9   ;  |  |   of the pattern on each test
 dec a        ;--+--+--
 call z,ld7   ;  |  |
 dec a
 call z,ld8
 dec a
 call z,ld9
 dec a
 call z,ld9
 dec a
 call z,ld7
 ret
ct2:     ;second test
 ld a,(temp2)
 ld hl,t
 cp (hl)
 jr nz,ct3   
 ld a,(temp2)
 ld hl,temp3
 cp (hl)    ;if not equal next test
 jr nz,ct3  
 ld a,(temp1)
 or a    ;is peice zero?
 jr nz,ct3   ;if not next test
 ld a,b   ;otherwise get the test counter
 ld hl,comppeice
 dec a    ;and place the peice
 call z,ld1
 dec a 
 call z,ld4   ; 0| A|A  the first A is temp2 2nd A temp3 0 is temp1
 dec a        ;--+--+--  
 call z,ld7   ;  |  |
 dec a        ;--+--+--
 call z,ld1   ;  |  |
 dec a
 call z,ld2
 dec a
 call z,ld3
 dec a
 call z,ld1
 dec a
 call z,ld3
 ret
ct3:     ;third test 
 ld a,(temp1)
 ld hl,t
 cp (hl)
 ret nz
 ld a,(temp1)
 ld hl,temp3
 cp (hl)    ;if not equal next test
 ret nz  
 ld a,(temp2)
 or a    ;is peice zero?
 ret nz    ;if not next test
 ld a,b    ;otherwise get the test counter
 ld hl,comppeice
 dec a    ;and place the peice
 call z,ld2
 dec a
 call z,ld5
 dec a
 call z,ld8
 dec a
 call z,ld4
 dec a
 call z,ld5
 dec a
 call z,ld6
 dec a
 call z,ld5
 dec a 
 call z,ld5
 ret 
ld1:   ;these labels here were for the 'psuedoconditional load'
    ;section because a condtional ld doesnt exist
 ld c,1
 ld (hl),c
 ret
ld2:
 ld c,2
 ld (hl),c
 ret
ld3:
 ld c,3
 ld (hl),c
 ret
ld4:
 ld c,4
 ld (hl),c
 ret
ld5:
 ld c,5
 ld (hl),c
 ret
ld6:
 ld c,6
 ld (hl),c
 ret
ld7:
 ld c,7
 ld (hl),c
 ret
ld8:
 ld c,8
 ld (hl),c
 ret
ld9:
 ld c,9
 ld (hl),c
 ret
random:   ;i got this from ztetris by Jimmy Mardell <yarin@acc.umu.se>
 ld b,a  ;generates random# 0<=n<a imput a = rand num to output A rand num
 ld a,r  ;this is the magic part its the refresh memory register
 add a,a  ;doubles value, back in a
 ld hl,0
 ld d,0
 ld e,a
RMul:
 add hl,de
 djnz RMul
 ld a,h
 ret
;;;;;;;end comp section;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
maintest:
;will check for 3 of same value here
 ld hl,temp1
 ld b,3
maintestloop:
 ld a,(hl)  ;loads value of temps into a the rets if a temp is = 0 (no piece)
 or a   ;this loop saves 1 byte hehe
 ret z
 inc hl   ;next temp vari
 djnz maintestloop 
;if it got here then the 3 tested squares are filled up, but are they the same value?
;thats what the next section is for...
 ld a,(temp1) 
 ld hl,temp2
 cp (hl)
 ret nz
 ld hl,temp3
 cp (hl)
 ret nz
 ld a,(temp2)
 ld hl,temp3
 cp (hl)
 ret nz
 ld a,1  ;set win to one because someone won
 ld (win),a 
 ret
someonewan:
 ld hl,$0700
 ld (_curRow),hl
 ld a,(t) ;get the turn of who won
 dec a
 jr z,onewon
 ld hl,o
 jr dispwin
onewon:
 ld hl,x
dispwin:
 call _puts
 call _homeup
 ld hl,playerwintxt1
 call _puts
 ld hl,$0900
 ld (_curRow),hl
 ld hl,playerwintxt2
 call _puts
menu:
;options here are switch mode, new game, end.
 ld hl,$2549
 ld (_penCol),hl
 ld hl,menutxt2
 call _vputs
 ld hl,$2C49
 ld (_penCol),hl
 ld hl,menutxt3
 call _vputs
 ld hl,$3349
 ld (_penCol),hl
 ld hl,menutxt4
 call _vputs
menukey:
 halt \ halt;same some energy
 call _getkey
 cp k1
 jp z,resetvaris
 cp k2
 jp z,start
 cp k3
 jr z,exit
 cp kExit
 jr z,exit
 jr menukey
exit:
 res 4,(iy+9)    ;if you pressed on it wont say break after quiting
 res 3,(iy+18)    ;reset shift
 res textInverse,(iy+textflags);resets the inverse text
 set graphdraw,(iy+graphflags);tell os to redraw graph
 set appTextSave,(IY+appflags);resets textshadow
 call _clrScrn    ;clears the screen
        ;sorry about before nothing serius but if you stopped playing
        ;then turned off calc with os _off function
        ;(restores textshadow) it would have a bunch of junk on the 
        ;screen - its fixed now
 ret       ;returns to shell or ti os
;;;;;;;;;;;;;;;;;;;;;
;my titlepict encoded by pic2rle encoder
tttpict: .db 12,7,"tttpict"
;strings are next
author:
 .db "by Ricky Cobb",0
push2ndtxt:
 .db "Push 2nd",0
 .db "to continue",0
playerstxt2:
 .db "1 Player",0
playerstxt3:
 .db "2 Player",0
error:
 .db "Nope!",0
blank:
 .db "                  ",0
x:
 .db "X",0
o:
 .db "O",0
playerwintxt1:
 .db "Player ",0
xturn:
 .db "X's turn",0
playerwintxt2:
 .db "Wins!",0
cat:
 .db "Cat Game!  ",0
menutxt:
 .db "Tic Tac Toe",0
threeinrow:
 .db "3 in a row",0
keystxt:
 .db "Keys",0
keytxt2:
 .db "789",0
keytxt3:
 .db "456",0
keytxt4:
 .db "123",0
menutxt2:
 .db "1: NEW GAME",0
menutxt3:
 .db "2: SWITCH MODE",0
menutxt4:    ;the extra spaces erase whats behind it
 .db "3: END          ",0  
;incase you were wondering the NUL (zero 0) at the end of the string tells
;the processor to stop 'fetching' the data (string) and go back to next
;instuction -  its called a nul-terminated string
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;+++++++++++++++end of my code+++++++++++++++++++++++;
;the following is David's picture compresser         ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;========================================================
; RLE picture displayer v1.5
; Decodes a RLE picture made by 
;  Pic2RLE/Asm Toolbox/Image Studio
;
; written by David Phillips <david@acz.org>
; thanks to Clem Vasseur <darkclem@wanadoo.fr>
; for some helpful hints, like LDI setting Parity Odd
; started: 8/19/98
; last update: 7/5/99
;
; input: HL = RLE encoded picture, DE = where to display
; output: decoded picture of size specified on first line
; destroys: AF, BC, DE, HL
; current size: 28 bytes
;========================================================
DispRLE:
 ld bc,1024
DispRLELoop:
 ld a,$91
 cp (hl)
 jr nz,DispRLENotRun
 inc hl
 inc hl
 ld a,(hl)
 dec hl
DispRLERun:
 ldi
 ret po
 dec hl
 dec a
 jr nz,DispRLERun
 inc hl
 inc hl
 jr DispRLELoop
DispRLENotRun:
 ldi
 ret po
 jr DispRLELoop

.end
